"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const handlebars = require("handlebars");
const TEMPLATE = `/**
 * Auto generated, do not modify!
 */
/* eslint-disable */

import { DatabaseDefinition } from "typescript-mysql-model";
export class Definition {
  public static readonly schema: DatabaseDefinition.IDatabaseSchema = {{schema}};

}`;
class DefinitionBuilder {
    constructor(model) {
        this.model = model;
        const modelCopy = JSON.parse(JSON.stringify(model));
        for (const viewName in modelCopy.views) {
            const view = modelCopy.views[viewName];
            for (const colName in view) {
                const col = view[colName];
                delete col.default;
            }
        }
        this.compiledTemplate = handlebars.compile(TEMPLATE, { noEscape: true });
    }
    renderSchema() {
        return this.compiledTemplate({ schema: JSON.stringify(this.model, undefined, 2) });
    }
}
exports.DefinitionBuilder = DefinitionBuilder;
//# sourceMappingURL=definition-builder.js.map