"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enum_merger_1 = require("./enum-merger");
class EnumBuilder {
    run(schema) {
        let tableEnums = [];
        for (const tableKey in schema.tables) {
            const table = schema.tables[tableKey];
            const enums = this.enumArr(table, tableKey);
            tableEnums.push(...enums);
        }
        return new enum_merger_1.EnumMerger().mergeEnums(tableEnums);
    }
    enumArr(table, tableName) {
        const enums = [];
        for (const colKey in table) {
            const column = table[colKey];
            if (column.type === "enum" && column.enumValues) {
                enums.push({
                    field: column.field,
                    table: tableName,
                    optionHash: column.enumValues.sort().join(":"),
                    options: column.enumValues
                });
            }
        }
        return enums;
    }
}
exports.EnumBuilder = EnumBuilder;
//# sourceMappingURL=enum-builder.js.map