"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const changeCase = require("change-case");
const longest_common_substrng_1 = require("./longest-common-substrng");
const misc_1 = require("./misc");
class EnumMerger {
    mergeEnums(enums) {
        const dict = misc_1.groupBy(enums, "optionHash");
        const LCS_THRESHOLD = 5;
        const newEnums = new Map();
        for (const key in dict) {
            const value = dict[key];
            if (value.length === 1) {
                continue;
            }
            const lcs = value.reduce((p, c) => longest_common_substrng_1.longestCommonSubstring(p, changeCase.constant(c.field)), changeCase.constant(value[0].field));
            if (lcs.length > LCS_THRESHOLD) {
                const newName = changeCase.constant(lcs);
                const existing = newEnums.get(newName);
                if (!existing || existing.replacementFor.length < value.length) {
                    const newEnum = {
                        field: newName,
                        replacementFor: value,
                        table: changeCase.pascalCase(newName),
                        options: value[0].options,
                        optionHash: value[0].optionHash
                    };
                    newEnums.set(newName, newEnum);
                }
            }
        }
        const newArr = [...newEnums.values()];
        newArr.forEach(r => {
            var _a;
            (_a = r.replacementFor) === null || _a === void 0 ? void 0 : _a.forEach(s => s.replacedBy = r);
        });
        return [...enums, ...newArr];
    }
}
exports.EnumMerger = EnumMerger;
//# sourceMappingURL=enum-merger.js.map