import { ISetting } from "./isetting";
import { IDatabaseSchema, IDatabaseTable } from "./mysql-database-definition";
import { TableClass } from "./table-class";
export interface Dict<value> {
    [key: string]: value;
}
export declare class InterfaceBuilder {
    private settings;
    private mysqlTypes;
    private schema;
    private matcher;
    constructor(settings: ISetting, mysqlTypes: Dict<string>, schema: IDatabaseSchema);
    renderTs(tableClass: TableClass, table: IDatabaseTable): string;
    private importStatement;
    private getMetaText;
    private variableTypeRow;
    private variableTypeRowInsertItem;
    private variableTypeRowUpdateItem;
    private isEnum;
    private getTsType;
    renderUpdateType(tableClass: TableClass, table: IDatabaseTable): string;
    renderInsertType(tableClass: TableClass, table: IDatabaseTable): string;
}
